/******************************************************************************
 *
 * Copyright (c) 2007, ACCESS Systems Americas, Inc. All Rights Reserved.
 *
 * File: AppMain.c
 *
 *****************************************************************************/

/*
1. Follow segmentation guide to set variable MULTIPLE_CODE_SEGMETS for compiler.
2. Link with library CtlGlue by adding to PRC Tools 68K Linker option -lPalmOSGlue
*/

#include <PalmOS.h>
#include <PalmCompatibility.h>
#include <Libraries/PalmOSGlue/CtlGlue.h>
#include <Control.h>
#include <Form.h>

//#include <stdlib.h>


#include "CXMLReaderImpl.h"
#include "AppResources.h"

#include "WidgetManager.h"
#include "ButtonWidget.h"
#include "LabelWidget.h"
#include "CheckboxWidget.h"
#include "ListWidget.h"
#include "SliderWidget.h"
#include "RadiobuttonWidget.h"
#include "GridWidget.h"

#include "writeXML.h"
#include "timeUtils.h"
#include "AppMain.h"
#include "../../Preferences.h"



/***********************************************************************
 *
 *	Global variables
 *
 ***********************************************************************/
//short displayWidth, displayHeight;
FormPtr pMainForm;
Boolean alarmRsp = false;
Boolean alarmUpdate = false;
LauncherPreferenceType prefs;
/***********************************************************************
 *
 *	Entry Points
 *
 ***********************************************************************/


/***********************************************************************
 *
 *	Internal Constants
 *
 ***********************************************************************/
#define appFileCreator			'MIHA'	// register your own at http://www.palmos.com/dev/creatorid/
#define appVersionNum			0x01
#define appPrefID				0x00
#define appPrefVersionNum		0x01

//TODO: global defines
#define sysAppLaunchCmdAlarmRet	32768
#define sysAppLaunchCmdAlarmStart 32769
#define sysAppLaunchCmdAlarmUpdate 32770


FileReadCallBack* cp = new FileReadCallBack("questions.xml");
CXMLReaderImpl xml = CXMLReaderImpl(cp, true);

WidgetManager* widgetManager = 0;

/***********************************************************************
 *
 * FUNCTION:    GetObjectPtr
 *
 * DESCRIPTION: This routine returns a pointer to an object in the active form.
 *
 * PARAMETERS:  objectID - id of the object
 *
 * RETURNED:    pointer to the object's data structure
 *
 ***********************************************************************/
VoidPtr GetObjectPtr(Int objectID)
{
	FormPtr frm;
	
	frm = FrmGetActiveForm();
	return(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, objectID)));
}


char manualStringBuffer[6];
char* isManualAsString()
{
	// TODO return real data: was program
	// launched manually by the user or by alarm?
	
	strcpy(manualStringBuffer, "true");
	return manualStringBuffer;
}







bool questionEndTagRead = false;
bool batteryEndTagRead  = false;
bool researchEndTagRead = false;
// TODO read and handle squQids, etc. from XML.
static void TestXMLParser()
{
	ListWidget* lastListWidget = 0;	
	AlarmPrefsType* alarmPrefs;
	UInt16	alarmPrefsSize;
	DateTimeType tempTime;
	while(xml.read())
	{
		switch(xml.getNodeType())
		{
		case EXN_TEXT:
			// Nothing to do here...
			break;
			
		case EXN_ELEMENT_END:
		
			if (!strcmp("research", xml.getNodeName())) {
				if (researchEndTagRead)
					return;
				
				if (questionEndTagRead) {
					XMLOpenFile("answer.xml");
					XMLWriteEndElem("question");
					XMLCloseFile();
					questionEndTagRead = false;
				}
				
				if (batteryEndTagRead) {
					XMLOpenFile("answer.xml");
					XMLWriteEndElem("battery");
					XMLCloseFile();
					batteryEndTagRead = false;
				}
							
				researchEndTagRead = true;
				XMLOpenFile("answer.xml");
				XMLWriteEndElem(xml.getNodeName());
				XMLWriteEndElem("answer");
				XMLCloseFile();
				
				if(alarmRsp)
					returnPreviousApp(sysAppLaunchCmdAlarmRet);
				else if(alarmUpdate)
					returnPreviousApp(sysAppLaunchCmdAlarmUpdate);
				else
					returnPreviousApp(sysAppLaunchCmdNormalLaunch);
			}
		
			if (!strcmp("battery", xml.getNodeName())) {
				batteryEndTagRead = true;
				//XMLOpenFile("answer.xml");
				//XMLWriteEndElem(xml.getNodeName());
				//XMLCloseFile();
			}		
				
			if (!strcmp("question", xml.getNodeName())) {
				questionEndTagRead = true;
				// Jump out of this funtion to pause XML-parsing
				// until user has answered the current question.
				return;
			}		
			
			if (!strcmp("alarms", xml.getNodeName())) {
				//Save alarmPrefs
				PrefSetAppPreferences(appFileCreator, AlarmPreferences, 
					1, alarmPrefs, sizeof(AlarmPrefsType), false);
				MemPtrFree(alarmPrefs);	
			}
			
		break;
		
		case EXN_ELEMENT:
			{	
				if (!strcmp("research", xml.getNodeName())) {										
					XMLOpenFile("answer.xml");
					
					// Write XML declaration-element
					XMLWriteXMLDeclaration("1.0", "ISO-8859-15");
					
					// Write answer-element
					XMLWriteStartOfContainerElem("answer");
					XMLWriteStringAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
					XMLWriteStringAttribute("xsi:noNamespaceSchemaLocation", "answer.xsd");
					XMLWriteStringAttribute("subject", prefs.deviceID);
					XMLWriteEndOfContainerElem();								

					// Write research-element																				
					XMLWriteStartOfContainerElem(xml.getNodeName());
					XMLWriteStringAttribute("rid", (char*)xml.getAttributeValueSafe("id"));
					XMLWriteStringAttribute("name", (char*)xml.getAttributeValueSafe("name"));
					XMLWriteEndOfContainerElem();
					
					XMLCloseFile();
				}
				
				if (!strcmp("battery", xml.getNodeName())) {
					
					if (questionEndTagRead) {
						XMLOpenFile("answer.xml");
						XMLWriteEndElem("question");
						XMLCloseFile();
						questionEndTagRead = false;
					}
					
					if (batteryEndTagRead) {
						XMLOpenFile("answer.xml");
						XMLWriteEndElem(xml.getNodeName());
						XMLCloseFile();
						batteryEndTagRead = false;					
					}
					
					XMLOpenFile("answer.xml");	
					XMLWriteStartOfContainerElem(xml.getNodeName());
					XMLWriteStringAttribute("bid", (char*)xml.getAttributeValueSafe("id"));
					XMLWriteStringAttribute("name", (char*)xml.getAttributeValueSafe("name"));
					XMLWriteStringAttribute("time", getCurrentDateTime());
					XMLWriteStringAttribute("manual", isManualAsString());
					XMLWriteEndOfContainerElem();
					XMLCloseFile();
				}
				
				
				if (!strcmp("question", xml.getNodeName())) {
					widgetManager->removeAll();
					lastListWidget = 0;
					
					if (questionEndTagRead) {
						XMLOpenFile("answer.xml");
						XMLWriteEndElem(xml.getNodeName());
						XMLCloseFile();
						questionEndTagRead = false;
					}
					
					XMLOpenFile("answer.xml");
					XMLWriteStartOfContainerElem(xml.getNodeName());
					XMLWriteStringAttribute("qid", (char*)xml.getAttributeValueSafe("id"));
					XMLWriteStringAttribute("name", (char*)xml.getAttributeValueSafe("name"));
					XMLWriteStringAttribute("time", getCurrentDateTime());
					XMLWriteEndOfContainerElem();
					XMLCloseFile();
				}	
				
				if(!strcmp("alarm", xml.getNodeName())) {
					//Add alarm	
					alarmPrefs->alarms[alarmPrefs->alarmsPerDay] = 
						xmlTimeToSeconds(xml.getAttributeValueSafe("start"));
					alarmPrefs->alarmsPerDay++;
				}
				
				if(!strcmp("random", xml.getNodeName())) {
					//Set random
					alarmPrefs->random = 1;
					alarmPrefs->alarmsPerDay = StrAToI(xml.getAttributeValueSafe("numAlarmsInDay"));
					alarmPrefs->minRndInterval = StrAToI(xml.getAttributeValueSafe("minMinutesBetween"));
				}
				
				if(!strcmp("alarms", xml.getNodeName())) {
					//Load AlarmPrefs
					alarmPrefs = (AlarmPrefsType*) MemPtrNew(sizeof(AlarmPrefsType));
					alarmPrefsSize = sizeof(AlarmPrefsType);
					
					//New alarms found, old will be owerwritten
					alarmPrefs->alarmsPerDay = 0;	
					PrefGetAppPreferences(appFileCreator, 
						AlarmPreferences, alarmPrefs, &alarmPrefsSize, false);
						
					//Set to true so new alarm will be set on return
//					alarmUpdate = true; 
	
					//Set research dates
					xmlToPalmDateTime(xml.getAttributeValueSafe("start"), &tempTime);
					alarmPrefs->alarmsStartDate = tempTime;
					xmlToPalmDateTime(xml.getAttributeValueSafe("end"), &tempTime);
					alarmPrefs->alarmsEndDate = tempTime;
				}
				
				if (!strcmp("reset", xml.getNodeName())) {
					// TODO currently doing this would remove ALSO the beginning
					// of this answer.
					//XMLClearFile();
				}
				
				if (!strcmp("button", xml.getNodeName())) {
					widgetManager->addWidget(new ButtonWidget(&pMainForm, &xml, &TestXMLParser));
				}
				
				if (!strcmp("checkbox", xml.getNodeName())) {
					widgetManager->addWidget(new CheckboxWidget(&pMainForm, &xml));
				}				
				
				if (!strcmp("label", xml.getNodeName())) {
					widgetManager->addWidget(new LabelWidget(&pMainForm, &xml));
				}				
								
				if (!strcmp("list", xml.getNodeName())) {
					lastListWidget = new ListWidget(&pMainForm, &xml);
					widgetManager->addWidget(lastListWidget);
				}								
				
				if (!strcmp("item", xml.getNodeName())) {
					if (lastListWidget)
						lastListWidget->addItem(new ItemWidget(&pMainForm, &xml, lastListWidget));
				}
												
				if (!strcmp("slider", xml.getNodeName())) {
					widgetManager->addWidget(new SliderWidget(&pMainForm, &xml));
				}
				
				if(!strcmp("radiobutton", xml.getNodeName())){
					widgetManager->addWidget(new RadiobuttonWidget(&pMainForm, &xml));
				}
				
				if(!strcmp("grid", xml.getNodeName())){
					widgetManager->addWidget(new GridWidget(&pMainForm, &xml, &GadgetHandler));
				}
								
			}
			break;
			
			default:
			break;
		}
	}	
}

/***********************************************************************
 *
 * FUNCTION:    MainFormDoCommand
 *
 * DESCRIPTION: This routine performs the menu command specified.
 *
 * PARAMETERS:  command  - menu item id
 *
 * RETURNED:    nothing
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Boolean MainFormDoCommand(UInt16 command)
{
	Boolean handled = false;
	FormType * pForm;

	switch (command) {
		case MainOptionsAboutStarterApp:
			pForm = FrmInitForm(AboutForm);
			FrmDoDialog(pForm);					// Display the About Box.
			FrmDeleteForm(pForm);
			handled = true;
			break;
	}

	return handled;
}



/***********************************************************************
 *
 * FUNCTION:    MainFormHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the 
 *              "MainForm" of this application.
 *
 * PARAMETERS:  pEvent  - a pointer to an EventType structure
 *
 * RETURNED:    true if the event has handle and should not be passed
 *              to a higher level handler.
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Boolean MainFormHandleEvent(EventType* pEvent)
{
	Boolean 	handled = false;
	FormType* 	pForm;

	switch (pEvent->eType) {
		case menuEvent:
			return MainFormDoCommand(pEvent->data.menu.itemID);

		case frmOpenEvent:
			pForm = FrmGetActiveForm();
			pMainForm = pForm;
			if (widgetManager == 0)
				widgetManager = new WidgetManager(&pMainForm);
				
			XMLClearFile();
			TestXMLParser();
			FrmDrawForm(pForm);
			handled = true;
			break;
			
		default:			
			break;
	}
	
	return handled;
}


void returnPreviousApp(UInt32 launchCode)
{
	Err         err;
	LocalID     dbID = DmFindDatabase(0, "Launcher");
	
	if (dbID) {
		err = SysUIAppSwitch (0,dbID,launchCode ,0);
	}	
}


/***********************************************************************
 *
 * FUNCTION:    AppHandleEvent
 *
 * DESCRIPTION: This routine loads form resources and set the event
 *              handler for the form loaded.
 *
 * PARAMETERS:  event  - a pointer to an EventType structure
 *
 * RETURNED:    true if the event has handle and should not be passed
 *              to a higher level handler.
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Boolean AppHandleEvent(EventType* pEvent)
{
	UInt16 		formId;
	FormType* 	pForm;
	Boolean		handled = false;
	
	if (pEvent->eType == frmLoadEvent) {
		// Load the form resource.
		formId = pEvent->data.frmLoad.formID;
		
		pForm = FrmInitForm(formId);
		FrmSetActiveForm(pForm);

		// Set the event handler for the form.  The handler of the currently
		// active form is called by FrmHandleEvent each time is receives an
		// event.
		switch (formId) {
			case MainForm:
				FrmSetEventHandler(pForm, MainFormHandleEvent);
				break;

			default:
				break;
		}
		handled = true;
	}

    if (pEvent->eType == lstSelectEvent) {
			Widget* w = widgetManager->getWidget(pEvent->data.lstSelect.listID);
			if (w != 0)
				w->onSelect(pEvent);
	}
	
	if (pEvent->eType == ctlSelectEvent) {
		
		if (pEvent->data.ctlSelect.controlID == ButtonDone) {			
			TestXMLParser();
			return true;
			
		}
		else {
			Widget* w = widgetManager->getWidget(pEvent->data.ctlSelect.controlID);
			
			if (w != 0) {
				w->onSelect(pEvent);					
				return true;
			} else {
				return false;
			}
        }
	}
		
	return handled;
}

static Boolean GadgetHandler (struct FormGadgetTypeInCallback *gadgetP, UInt16 cmd, void *paramP)
{ 
	PointType selected = {-1, -1};

	Boolean handled = false; 
	EventType* eventPtr;
	eventPtr = (EventType*) paramP;
  GridWidget* w = 0;
   switch (cmd) { 
      case formGadgetDrawCmd: 
      //Sent to active gadgets any time form is  
  	  //drawn or redrawn. 
  	 w = (GridWidget*)widgetManager->getWidget(gadgetP->id);
		if (w)
			w->DrawGadget(gadgetP->rect, selected);
	//DrawGadget(gadgetP->rect, selected);
   		 gadgetP->attr.visible = true; 
   		 handled = true; 
   		 break; 
   
  	case formGadgetHandleEventCmd: 
  	//Sent when form receives a gadget event.  
 		if (eventPtr->eType == frmGadgetEnterEvent) { 
 		// penDown in gadget's bounds.  
 			
			w = (GridWidget*)widgetManager->getWidget(gadgetP->id);
			if (w)
				w->onSelect(gadgetP, eventPtr);
			//onSelect(gadgetP, eventPtr);

    		handled = true; 
 		} 
 		if (eventPtr->eType == frmGadgetMiscEvent) { 
    	//This event is sent by your application 
    	//when it needs to send info to the gadget 
    	} 
    	break; 
  	case formGadgetDeleteCmd:  
    	//Perform any cleanup prior to deletion. 
    	break; 
  	case formGadgetEraseCmd:  
  	//FrmHideObject takes care of this if you  
  	//return false.  
    	handled = false; 
    	//handled = true;
    	break; 
   } 
   return handled; 
} 

	


/***********************************************************************
 *
 * FUNCTION:     AppStart
 *
 * DESCRIPTION:  Get the current application's preferences.
 *
 * PARAMETERS:   nothing
 *
 * RETURNED:     Err value errNone if nothing went wrong
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Err AppStart(void)
{
	//Load preferences or set defaults
	UInt16 prefsize = sizeof(LauncherPreferenceType);
	if(PrefGetAppPreferences(appFileCreator, LauncherPreferences, &prefs, &prefsize, false) 
	== noPreferenceFound){
		//TODO: set Defaults?;
	}
		
	FrmGotoForm(MainForm);
	return errNone;
}


/***********************************************************************
 *
 * FUNCTION:    AppStop
 *
 * DESCRIPTION: Save the current state of the application.
 *
 * PARAMETERS:  nothing
 *
 * RETURNED:    nothing
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static void AppStop(void)
{
	
	// Save preferences
	PrefSetAppPreferences(appFileCreator, LauncherPreferences, 
	1, &prefs, sizeof(LauncherPreferenceType), false);
	
	if (widgetManager) {
		widgetManager->removeAll();
		delete widgetManager;
		widgetManager = 0;
	}
	
	// Close all the open forms.
	FrmCloseAllForms();	
}


/***********************************************************************
 *
 * FUNCTION:    AppEventLoop
 *
 * DESCRIPTION: This routine is the event loop for the application.  
 *
 * PARAMETERS:  nothing
 *
 * RETURNED:    nothing
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static void AppEventLoop(void)
{
	Err			error;
	EventType	event;

	do {
		EvtGetEvent(&event, evtWaitForever);

		if (SysHandleEvent(&event))
			continue;
			
		if (MenuHandleEvent(0, &event, &error))
			continue;
			
		if (AppHandleEvent(&event))
			continue;

		FrmDispatchEvent(&event);

	} while (event.eType != appStopEvent);
}


/***********************************************************************
 *
 * FUNCTION:    PilotMain
 *
 * DESCRIPTION: This is the main entry point for the application.
 *
 * PARAMETERS:  cmd - word value specifying the launch code. 
 *              cmdPB - pointer to a structure that is associated with the launch code. 
 *              launchFlags -  word value providing extra information about the launch.
 * RETURNED:    Result of launch
 *
 * REVISION HISTORY: 
 *
 *
 ***********************************************************************/
UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
	Err error = errNone;

	switch (cmd) {
		case sysAppLaunchCmdNormalLaunch:
			if ((error = AppStart()) == 0) {			
				AppEventLoop();
				AppStop();
			}
			break;
		case sysAppLaunchCmdAlarmStart:
			alarmRsp = true;
			if ((error = AppStart()) == 0) {			
				AppEventLoop();
				AppStop();
			}			
		default:
			break;
	}

	return error;
}


