#include "ButtonWidget.h"

extern void TestXMLParser();

	ButtonWidget::ButtonWidget(FormPtr* form, CXMLReaderImpl* xml, void (*callback)(void))
		: Widget(form, xml), m_callback(callback)
	{		
		m_x = xml->getAttributeValueAsInt("x");
		m_y = xml->getAttributeValueAsInt("y");
		m_width = xml->getAttributeValueAsInt("width");
		m_height = xml->getAttributeValueAsInt("height");
		
		CtlNewControl( (void**)form,                                    // formPP
					    getId(),                                        // ID
					    buttonCtl,                                      // style
					    xml->getAttributeValueSafe("text"),             // textP
					    m_x,                                            // x
					    m_y,                                            // y
					    m_width,                                        // width
					    m_height,                                       // height
					    stringToFontID(xml->getAttributeValue("font")), // font
					    0,                                              // group 
					    false                                           // leftAnchor
					  );
					  					    
		FrmDrawForm(*form);
		m_subQid = xml->getAttributeValueAsInt("subQid");
	}
	
	ButtonWidget::~ButtonWidget()
	{
	}
	
	void ButtonWidget::onSelect(EventType* event)
	{
		XMLOpenFile("answer.xml");				
		XMLWriteStartOfEmptyElem("buttonEvent");
		XMLWriteIntAttribute("id", event->data.ctlSelect.controlID);
		XMLWriteStringAttribute("text", CtlGetLabel(event->data.ctlSelect.pControl));
		XMLWriteStringAttribute("time", getCurrentDateTime());
		XMLWriteEndOfEmptyElem();
		XMLCloseFile();
		
		if (m_callback)
			m_callback();
	}
	
