#include "GridWidget.h"

UInt16 GridWidget::m_data;

	GridWidget::GridWidget(FormPtr* form, CXMLReaderImpl* xml, Boolean (*handler)(struct FormGadgetTypeInCallback *gadgetP, UInt16 cmd, void *paramP))
		: Widget(form, xml)
	{
		//UInt16*	data = (UInt16*)MemPtrNew(sizeof(UInt16));
		FrmNewGadget(form, getId(), 35, 35, 90, 90);
		//FrmSetGadgetData(*form, FrmGetObjectIndex(*form, getId()), data); //use for passing data to handler
		FrmSetGadgetData(*form, FrmGetObjectIndex(*form, getId()), &(GridWidget::m_data)); //use for passing data to handler
		FrmSetGadgetHandler(*form, FrmGetObjectIndex(*form, getId()), /*GadgetHandler*/ handler);
	}
	
	
	
	GridWidget::~GridWidget()
	{
	}
	
	void GridWidget::onSelect(EventType* event)
	{
		
	}
	
	void GridWidget::onSelect(FormGadgetTypeInCallback* event, EventType* eventPtr) 
	{
		PointType selected = {-1, -1};
		selected.x = eventPtr->screenX;
		selected.y = eventPtr->screenY;
		
		DrawGadget(event->rect, selected);
 			
		XMLOpenFile("answer.xml");	
		XMLWriteStartOfEmptyElem("gridEvent");
		XMLWriteIntAttribute("id", event->id);
		XMLWriteIntAttribute("x", selected.x - event->rect.topLeft.x);
		XMLWriteIntAttribute("y", selected.y - event->rect.topLeft.y);
		XMLWriteStringAttribute("time", getCurrentDateTime());
		XMLWriteEndOfEmptyElem();
		XMLCloseFile();
	}
	
	//Todo: more efficent redraw, drawing labels, fix colors
	void GridWidget::DrawGadget(RectangleType rect, PointType selected){
	Int32	i;
	RectangleType drawnRect;
			
	WinEraseRectangle(&rect, 0);			
	
//	WinSetForeColor(16);
	
	//Gridlines y-axis			
	for(i = rect.topLeft.y + 6; i < rect.topLeft.y + rect.extent.y; i += 6){
		WinDrawLine(rect.topLeft.x, i, rect.extent.x + rect.topLeft.x, i);	
	}
	
	//Gridlines x-axis
	for(i = rect.topLeft.x + 6; i < rect.extent.x + rect.topLeft.x; i += 6){
		WinDrawLine(i, rect.extent.y + rect.topLeft.y, i, rect.topLeft.y);
	}
	
	WinDrawLine(rect.topLeft.x, rect.topLeft.y + (rect.extent.y / 2) + 1, rect.topLeft.x +
	rect.extent.x, rect.topLeft.y + (rect.extent.y / 2) + 1);
	
	WinDrawLine(rect.topLeft.x, rect.topLeft.y + (rect.extent.y / 2) - 1, rect.topLeft.x +
	rect.extent.x, rect.topLeft.y + (rect.extent.y / 2) - 1);


	WinDrawLine(rect.topLeft.x + (rect.extent.x / 2) + 1, rect.topLeft.y, 
	rect.topLeft.y + (rect.extent.y / 2) + 1, rect.topLeft.y + rect.extent.y);

	WinDrawLine(rect.topLeft.x + (rect.extent.x/ 2) - 1, rect.topLeft.y, 
	rect.topLeft.y + (rect.extent.y / 2) - 1, rect.topLeft.y + rect.extent.y);
	
	//Frame
//	WinDrawRectangleFrame(simpleFrame, &rect);
		
	//Selection
	if(selected.x > 0){
//		WinSetForeColor(100);
		drawnRect.topLeft.x = selected.x - 3;
		drawnRect.topLeft.y = selected.y - 3;

		drawnRect.extent.x = 7;
		drawnRect.extent.y = 7;
		
		WinDrawRectangle(&drawnRect, 4);
	}
}

	
	
