#include "ListWidget.h"
#include <stdlib.h>

	ItemWidget::ItemWidget(FormPtr* form, CXMLReaderImpl* xml, ListWidget* list)
		: Widget(form, xml), m_list(list), m_text(0)
	{		
		m_text = (char*)malloc(sizeof(char)*(strlen(xml->getAttributeValueSafe("text"))+1));
		strcpy(m_text, xml->getAttributeValueSafe("text"));
		m_subQid = xml->getAttributeValueAsInt("subQid");	
	}
	
	ItemWidget::~ItemWidget()
	{
		if (m_text != 0)
			free(m_text);
			
		m_text = 0;
	}
	
	void ItemWidget::onSelect(EventType* event)
	{
	}
	
	const char* ItemWidget::getText()
	{
		return m_text;
	}

	ListWidget::ListWidget(FormPtr* form, CXMLReaderImpl* xml)
		: Widget(form, xml), m_items(0), m_texts(0), m_currentItem(0), m_numItems(0)
	{
		m_x = xml->getAttributeValueAsInt("x");
		m_y = xml->getAttributeValueAsInt("y");
		m_width = xml->getAttributeValueAsInt("width");
		m_height = xml->getAttributeValueAsInt("height");
		m_numItems = xml->getAttributeValueAsInt("numItems");
		m_numVisible = xml->getAttributeValueAsInt("numVisible");
		m_font = stringToFontID(xml->getAttributeValue("font"));
		
		m_items = (ItemWidget**)malloc(sizeof(ItemWidget*)*m_numItems);
		m_texts = (const char**)malloc(sizeof(char*)*m_numItems);
	}
	
	void ListWidget::addItem(ItemWidget* widget)
	{
		if (m_currentItem < m_numItems) {
			m_items[m_currentItem] = widget;
			m_texts[m_currentItem] = widget->getText();
			m_currentItem++;
		}
		
		if (m_currentItem == m_numItems) {
			ListPtr pList;		
			LstNewList((void**)getForm(), getId(), m_x, m_y, m_width, m_height, m_font, m_numVisible, 0);
			pList = (ListPtr)GetObjectPtr(getId());
	
			if (pList)
				LstSetListChoices(pList, (char**)m_texts, m_numItems);			
		
			FrmDrawForm(*getForm());			
		}
	}
	
	ListWidget::~ListWidget()
	{
		if (m_items != 0) {
			for (int i = 0; i < m_numItems; i++) {
				if (m_items[i] != 0) {
					delete (m_items[i]);
					m_items[i] = 0;
				}
			}
			
			free(m_items);
			m_items = 0;
			m_currentItem = 0;
			m_numItems = 0;
			
			if (m_texts) {
				free(m_texts);
				m_texts = 0;
			}
		}
	}
	
	void ListWidget::onSelect(EventType* event)
	{
		XMLOpenFile("answer.xml");	
			XMLWriteStartOfEmptyElem("listEvent");
			XMLWriteIntAttribute("id", event->data.lstSelect.listID);
			Int16 itemNum = LstGetSelection(event->data.lstSelect.pList);
			if (itemNum != noListSelection) {
				XMLWriteStringAttribute("text", LstGetSelectionText(event->data.lstSelect.pList, itemNum));
			}
			XMLWriteStringAttribute("time", getCurrentDateTime());
			XMLWriteEndOfEmptyElem();
			XMLCloseFile();
	}
			
