#include "RadiobuttonWidget.h"

	RadiobuttonWidget::RadiobuttonWidget(FormPtr* form, CXMLReaderImpl* xml)
		: Widget(form, xml)
	{
		
		m_groupid = xml->getAttributeValueAsInt("groupid");
		m_subQid  = xml->getAttributeValueAsInt("subQid");
		
		// Parameters: formPP, ID, style, textP, x, y, width, height, font, group, leftAnchor
		CtlNewControl( (void**)form,
					   getId(),
					   pushButtonCtl,
					   xml->getAttributeValueSafe("text"),
					   xml->getAttributeValueAsInt("x"),
					   xml->getAttributeValueAsInt("y"),
					   xml->getAttributeValueAsInt("width"),
					   xml->getAttributeValueAsInt("height"),
					   stringToFontID(xml->getAttributeValue("font")),
					   m_groupid,
					   false);
					   
		FrmDrawForm(*form);
	}
	
	RadiobuttonWidget::~RadiobuttonWidget()
	{
	}
	
	void RadiobuttonWidget::onSelect(EventType* event)
	{
		XMLOpenFile("answer.xml");				
		XMLWriteStartOfEmptyElem("radiobuttonEvent");
		XMLWriteIntAttribute("id", event->data.ctlSelect.controlID);				
		XMLWriteIntAttribute("groupid", m_groupid);
		XMLWriteStringAttribute("text", CtlGetLabel(event->data.ctlSelect.pControl));
		XMLWriteStringAttribute("time", getCurrentDateTime());
		XMLWriteEndOfEmptyElem();
		XMLCloseFile();
	}
	
