#include "WidgetManager.h"

WidgetManager::WidgetManager(FormPtr* form)
	: m_numWidgets(0), m_form(form)
{
	for (int i = 0; i < MAX_WIDGETS; i++)
		m_widgets[i] = 0;
}

WidgetManager::~WidgetManager()
{
	removeAll();
}
	
void WidgetManager::addWidget(Widget* widget)
{
	// TODO array should grow, limits should be checked or...
	m_widgets[m_numWidgets] = widget;
	m_numWidgets++;
}

Widget* WidgetManager::getWidget(int id)
{
	for (int i = 0; i < m_numWidgets; i++) {
		if (m_widgets[i] && m_widgets[i]->getId() == id)
			return m_widgets[i];
	}
	
	return 0;	
}

void WidgetManager::removeAll()
{
	for (int i = 0; i < m_numWidgets; i++) {
		if (m_widgets[i] != 0) {
			FormPtr* pform = m_widgets[i]->getForm();	
			FrmRemoveObject(pform, FrmGetObjectIndex(*pform, m_widgets[i]->getId()));
			//FrmRemoveObject(m_form, FrmGetObjectIndex(*m_form, m_widgets[i]->getId()));
							
			delete m_widgets[i];
		}
			
		m_widgets[i] = 0;		
	}
	
	m_numWidgets = 0;
}

unsigned int WidgetManager::getNumWidgets()
{
	return m_numWidgets;
}