// Modified version by Kotilo. All modifications are under GPLv2. Original:
// Copyright (C) 2002-2005 Nikolaus Gebhardt
// This file is part of the "Irrlicht Engine" and the "irrXML" project.
// For conditions of distribution and use, see copyright notice in irrlicht.h and/or irrXML.h

#include "irrXML.h"
	
#include "irrString.h"
#include "irrArray.h"
#include "fast_atof.h"
#include "CXMLReaderImpl.h"
#include <string.h>

	
	FileReadCallBack::FileReadCallBack(const char* fileName)
		: m_fileH(0), m_size(0), m_close(true)
	{
		Err error = errNone;
		m_fileH = FileOpen(0, fileName, 0, 'MIHA', fileModeReadOnly, &error);
		if(error != errNone){
			ErrAlert(error);
			error = errNone;
		} else {		
			getFileSize();
		}
	}
	
	FileReadCallBack::~FileReadCallBack()
	{
		//if (close && fileH)
			FileClose(m_fileH);
	}
	
	//! Reads an amount of bytes from the file.
	int FileReadCallBack::read(void* buffer, int sizeToRead)
	{
		if (!m_fileH)
			return 0;

		Err error = errNone;
		return (int)FileRead(m_fileH, buffer, 1, sizeToRead, &error);
	    if(error != errNone){
		    ErrAlert(error);
       		error = errNone;
	    }	    
	}

	//! Returns size of file in bytes
	int FileReadCallBack::getSize()
	{
		return m_size;
	}

	//! retrieves the file size of the open file
	void FileReadCallBack::getFileSize()
	{
		Err error = errNone;
		FileSeek(m_fileH, 0, fileOriginEnd);
		FileTell(m_fileH, &m_size, &error);
		FileSeek(m_fileH, 0, fileOriginBeginning);
		
		if(error != errNone){
		    ErrAlert(error);
       		error = errNone;
	    }	    
	}
	