#include "writeXML.h"

#include <PalmOS.h>
#include <PalmCompatibility.h>
#include <Libraries/PalmOSGlue/CtlGlue.h>
#include <stdlib.h>

/*
 * TODO Escaping of text and some cleanup.
 */
 
FileHand outFileH;
int      indentSteps = 0;


void XMLClearFile()
{
	Err error = errNone;
	
    // Tiedoston avaus; muiskortin numero, tiedostonnimi, tyyppi, tekij, moodi, virhe ptr
    outFileH = FileOpen(0, "answer.xml", 0, 'MIHA', fileModeReadWrite, &error);
	if(error != errNone){
    	ErrAlert(error);
		error = errNone;
	}	
	FileTruncate(outFileH, 0);
	FileClose(outFileH);
}

void XMLOpenFile(const char* fileName)
{
	Err error = errNone;
	
    // Tiedoston avaus; muiskortin numero, tiedostonnimi, tyyppi, tekij, moodi, virhe ptr
    outFileH = FileOpen(0, fileName, 0, 'MIHA', fileModeAppend, &error);
	if(error != errNone){
    	ErrAlert(error);
		error = errNone;
	}
} 
 
void XMLWriteFile(const char* data)
{
	Err error = errNone;
	
	// Tiedostoon kirjoitus, parametrina kahva, kirjoitettava data, lohkon koko ja lohkojen mr 
	FileWrite(outFileH, data, 1, StrLen(data), &error);    
	if(error != errNone){
		ErrAlert(error);
		error = errNone;
	}
                           
}

void XMLCloseFile()
{
	FileFlush(outFileH);
	FileClose(outFileH);
}

void XMLWriteStartOfEmptyElem(const char* name)
{	
	int i;
	if (indentSteps > 0) {
		for (i = 0; i < indentSteps; i++)
			XMLWriteFile("\t");
	}
	
	XMLWriteFile("<");
	XMLWriteFile(name);	
	XMLWriteFile(" ");	
}

void XMLWriteStartOfContainerElem(const char* name)
{	
	int i;
	if (indentSteps > 0) {
		for (i = 0; i < indentSteps; i++)
			XMLWriteFile("\t");
	}
	
	XMLWriteFile("<");
	XMLWriteFile(name);
	XMLWriteFile(" ");
	indentSteps++;
}

void XMLWriteStringAttribute(const char* name, const char* value)
{
	XMLWriteFile(name);
	XMLWriteFile("=\"");
	XMLWriteFile(value);
	XMLWriteFile("\" ");
}

void XMLWriteIntAttribute(const char* name, const int value)
{
	char s[maxStrIToALen];
	//memset(s, '\0', maxStrIToALen);
	for (int i = 0; i < maxStrIToALen; i++) {
		s[i] = '\0';
	}
	StrIToA(s, value);
	XMLWriteStringAttribute(name, s);
}

void XMLWriteEndOfContainerElem()
{
	XMLWriteFile(">\n");
}

void XMLWriteEndOfEmptyElem()
{	
	XMLWriteFile("/>\n");
}

void XMLWriteEndElem(const char* name)
{
	int i;
	if (indentSteps > 0) {
		for (i = 1; i < indentSteps; i++)
			XMLWriteFile("\t");
	}
	
	XMLWriteFile("</");
	XMLWriteFile(name);
	XMLWriteFile(">\n");
	indentSteps--;	
}

void XMLWriteXMLDeclaration(const char* version, const char* encoding)
{
	XMLWriteFile("<?xml version=\"");
	XMLWriteFile(version);
	XMLWriteFile("\" encoding=\"");
	XMLWriteFile(encoding);
	XMLWriteFile("\"?>\n");
}
