#include "USB.h"

#define TO_PALM_NAME "ToPalm"
#define FROM_PALM_NAME "FromPalm"

FILE* fileToPalm;
FILE* fileFromPalm;

void clean_up()
{
    usb_disconnect();

    if (fileToPalm != NULL)
        fclose(fileToPalm);

    if (fileFromPalm != NULL)
        fclose(fileFromPalm);  
}

int main(void)
{
    int   to_palm_count;
    int   from_palm_count;
    char  to_palm_buffer[BUF_SIZE];
    int   i = 0;

    fileToPalm   = (FILE*)fopen(TO_PALM_NAME, "rb");
    
    if (fileToPalm == NULL)
       return 1;
    
    fileFromPalm = (FILE*)fopen(FROM_PALM_NAME, "wb");

    memset(to_palm_buffer, '\0', BUF_SIZE);
    to_palm_count = fread(to_palm_buffer, 1, BUF_SIZE, fileToPalm);

    if ( to_palm_count <= 0) {
        // TODO error
        return 1;
    }

    while(1) {
        /* try connecting until a connection is established or too many tries */
        if (usb_connect() != 0)
            break;

        if (++i >= CONNECTION_TRIES) {
            return 1;
        }
            
    }
        
    from_palm_count = usb_receive();

    if (from_palm_count > 0) {

        if (fileFromPalm == NULL) {
            clean_up();
            return 1;
        }

        fwrite(usb_get_message(), 1, strlen(usb_get_message()), fileFromPalm);
    }

    usb_send(to_palm_buffer, to_palm_count);
        
    clean_up();

    return 0;
}

