import java.net.URL;
import java.util.logging.Logger;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.SAXParseException;


public class QuestionParser {
	private static final Logger logger = Logger.getLogger(QuestionParser.class.getName());

	public void parseFile(URL questionURL) {
		QuestionHandler handler = new QuestionHandler();

		SAXParserFactory parserFactory = SAXParserFactory.newInstance();
		//parserFactory.setValidating(true);

		SAXParser parser;
		try {
			parser = parserFactory.newSAXParser();
			parser.parse(questionURL.toURI().toString(), handler);			
		} catch (Exception e) {
			if (e instanceof SAXParseException) {
				SAXParseException spe = (SAXParseException)e;
				logger.severe("Parsing error at "
						+ "line "  + spe.getLineNumber()
						+ ", uri " + spe.getSystemId()
						+ " : "    + spe.getMessage()
				);
			}
			return;
		}


	}
}
